3 # Copyright (c) 2005 Junio C Hamano
6 USAGE='[-n] [--no-commit] [--squash] [-s <strategy>] [-m=<merge-message>] <commit>+'
13 test -z "$(git ls-files -u)" ||
14 die "You are in the middle of a conflicted merge."
19 all_strategies='recur recursive octopus resolve stupid ours subtree'
20 default_twohead_strategies='recursive'
21 default_octopus_strategies='octopus'
22 no_trivial_merge_strategies='ours subtree'
28 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
29 "$GIT_DIR/MERGE_SAVE" || exit 1
33 # Stash away any local modifications.
34 git-diff-index -z --name-only $head |
35 cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
39 if test -f "$GIT_DIR/MERGE_SAVE"
41 git reset --hard $head >/dev/null
42 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
43 git-update-index --refresh >/dev/null
47 finish_up_to_date () {
50 echo "$1 (nothing to squash)" ;;
58 echo Squashed commit of the following:
60 git-log --no-merges ^"$head" $remote
66 rlogm="$GIT_REFLOG_ACTION"
69 rlogm="$GIT_REFLOG_ACTION: $2"
73 echo "Squash commit -- not updating HEAD"
74 squash_message >"$GIT_DIR/SQUASH_MSG"
79 echo "No merge message -- not updating HEAD"
82 git-update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
93 git-diff-tree --stat --summary -M "$head" "$1"
102 rh=$(git-rev-parse --verify "$remote^0" 2>/dev/null) || return
103 bh=$(git-show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
104 if test "$rh" = "$bh"
106 echo "$rh branch '$remote' of ."
107 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
108 git-show-ref -q --verify "refs/heads/$truname" 2>/dev/null
110 echo "$rh branch '$truname' (early part) of ."
111 elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
113 sed -e 's/ not-for-merge / /' -e 1q \
114 "$GIT_DIR/FETCH_HEAD"
116 echo "$rh commit '$remote'"
120 case "$#" in 0) usage ;; esac
123 while case "$#" in 0) break ;; esac
126 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
127 --no-summa|--no-summar|--no-summary)
129 --sq|--squ|--squa|--squas|--squash)
130 squash=t no_commit=t ;;
131 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
133 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
134 --strateg=*|--strategy=*|\
135 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
138 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
145 case " $all_strategies " in
147 use_strategies="$use_strategies$strategy " ;;
149 die "available strategies are: $all_strategies" ;;
152 -m=*|--m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
153 merge_msg=`expr "z$1" : 'z-[^=]*=\(.*\)'`
156 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
170 # This could be traditional "merge <msg> HEAD <commit>..." and the
171 # way we can tell it is to see if the second token is HEAD, but some
172 # people might have misused the interface and used a committish that
173 # is the same as HEAD there instead. Traditional format never would
174 # have "-m" so it is an additional safety measure to check for it.
176 if test -z "$have_message" &&
177 second_token=$(git-rev-parse --verify "$2^0" 2>/dev/null) &&
178 head_commit=$(git-rev-parse --verify "HEAD" 2>/dev/null) &&
179 test "$second_token" = "$head_commit"
185 elif ! git-rev-parse --verify HEAD >/dev/null 2>&1
187 # If the merged head is a valid one there is no reason to
188 # forbid "git merge" into a branch yet to be born. We do
189 # the same for "git pull".
192 echo >&2 "Can merge only exactly one commit into empty head"
196 rh=$(git rev-parse --verify "$1^0") ||
197 die "$1 - not something we can merge"
199 git-update-ref -m "initial pull" HEAD "$rh" "" &&
200 git-read-tree --reset -u HEAD
204 # We are invoked directly as the first-class UI.
207 # All the rest are the commits being merged; prepare
208 # the standard merge summary message to be appended to
209 # the given message. If remote is invalid we will die
210 # later in the common codepath so we discard the error
212 merge_name=$(for remote
215 done | git-fmt-merge-msg
217 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
219 head=$(git-rev-parse --verify "$head_arg"^0) || usage
221 # All the rest are remote heads
222 test "$#" = 0 && usage ;# we need at least one remote head.
223 set_reflog_action "merge $*"
228 remotehead=$(git-rev-parse --verify "$remote"^0 2>/dev/null) ||
229 die "$remote - not something we can merge"
230 remoteheads="${remoteheads}$remotehead "
231 eval GITHEAD_$remotehead='"$remote"'
232 export GITHEAD_$remotehead
234 set x $remoteheads ; shift
236 case "$use_strategies" in
240 var="`git-config --get pull.twohead`"
243 use_strategies="$var"
245 use_strategies="$default_twohead_strategies"
248 var="`git-config --get pull.octopus`"
251 use_strategies="$var"
253 use_strategies="$default_octopus_strategies"
259 for s in $use_strategies
261 for nt in $no_trivial_merge_strategies
274 common=$(git-merge-base --all $head "$@")
277 common=$(git-show-branch --merge-base $head "$@")
280 echo "$head" >"$GIT_DIR/ORIG_HEAD"
282 case "$index_merge,$#,$common,$no_commit" in
284 # We've been told not to try anything clever. Skip to real merge.
287 # No common ancestors found. We need a real merge.
290 # If head can reach all the merge then we are up to date.
291 # but first the most common case of merging one remote.
292 finish_up_to_date "Already up-to-date."
296 # Again the most common case of merging one remote.
297 echo "Updating $(git-rev-parse --short $head)..$(git-rev-parse --short $1)"
298 git-update-index --refresh 2>/dev/null
300 if test -n "$have_message"
302 msg="$msg (no commit created; -m option ignored)"
304 new_head=$(git-rev-parse --verify "$1^0") &&
305 git-read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
306 finish "$new_head" "$msg" || exit
311 # We are not doing octopus and not fast forward. Need a
315 # We are not doing octopus, not fast forward, and have only
317 git-update-index --refresh 2>/dev/null
318 case " $use_strategies " in
319 *' recursive '*|*' recur '*)
323 # See if it is really trivial.
324 git var GIT_COMMITTER_IDENT >/dev/null || exit
325 echo "Trying really trivial in-index merge..."
326 if git-read-tree --trivial -m -u -v $common $head "$1" &&
327 result_tree=$(git-write-tree)
332 git-commit-tree $result_tree -p HEAD -p "$1"
334 finish "$result_commit" "In-index merge"
342 # An octopus. If we can reach all the remote we are up to date.
346 common_one=$(git-merge-base --all $head $remote)
347 if test "$common_one" != "$remote"
353 if test "$up_to_date" = t
355 finish_up_to_date "Already up-to-date. Yeeah!"
361 # We are going to make a new commit.
362 git var GIT_COMMITTER_IDENT >/dev/null || exit
364 # At this point, we need a real merge. No matter what strategy
365 # we use, it would operate on the index, possibly affecting the
366 # working tree, and when resolved cleanly, have the desired tree
367 # in the index -- this means that the index must be in sync with
368 # the $head commit. The strategies are responsible to ensure this.
370 case "$use_strategies" in
372 # Stash away the local changes so that we can try more than one.
377 rm -f "$GIT_DIR/MERGE_SAVE"
382 result_tree= best_cnt=-1 best_strategy= wt_strategy=
384 for strategy in $use_strategies
386 test "$wt_strategy" = '' || {
387 echo "Rewinding the tree to pristine..."
390 case "$single_strategy" in
392 echo "Trying merge strategy $strategy..."
396 # Remember which strategy left the state in the working tree
397 wt_strategy=$strategy
399 git-merge-$strategy $common -- "$head_arg" "$@"
401 if test "$no_commit" = t && test "$exit" = 0
404 exit=1 ;# pretend it left conflicts.
407 test "$exit" = 0 || {
409 # The backend exits with 1 when conflicts are left to be resolved,
410 # with 2 when it does not handle the given merge at all.
412 if test "$exit" -eq 1
415 git-diff-files --name-only
416 git-ls-files --unmerged
418 if test $best_cnt -le 0 -o $cnt -le $best_cnt
420 best_strategy=$strategy
427 # Automerge succeeded.
428 result_tree=$(git-write-tree) && break
431 # If we have a resulting tree, that means the strategy module
432 # auto resolved the merge cleanly.
433 if test '' != "$result_tree"
435 parents=$(git-show-branch --independent "$head" "$@" | sed -e 's/^/-p /')
436 result_commit=$(echo "$merge_msg" | git-commit-tree $result_tree $parents) || exit
437 finish "$result_commit" "Merge made by $wt_strategy."
442 # Pick the result from the best strategy and have the user fix it up.
443 case "$best_strategy" in
446 case "$use_strategies" in
448 echo >&2 "No merge strategy handled the merge."
451 echo >&2 "Merge with strategy $use_strategies failed."
457 # We already have its result in the working tree.
460 echo "Rewinding the tree to pristine..."
462 echo "Using the $best_strategy to prepare resolving by hand."
463 git-merge-$best_strategy $common -- "$head_arg" "$@"
467 if test "$squash" = t
474 done >"$GIT_DIR/MERGE_HEAD"
475 echo "$merge_msg" >"$GIT_DIR/MERGE_MSG"
478 if test "$merge_was_ok" = t
481 "Automatic merge went well; stopped before committing as requested"
488 git ls-files --unmerged |
489 sed -e 's/^[^ ]* / /' |
491 } >>"$GIT_DIR/MERGE_MSG"
492 if test -d "$GIT_DIR/rr-cache"
496 die "Automatic merge failed; fix conflicts and then commit the result."